# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
import netsvc
import pooler
from osv import fields, osv

class sale_order_line(osv.osv):
    _inherit='sale.order.line'
    
    _columns={
        'date_cot' : fields.date('Fecha Cotizacion')
    }
    
    def product_id_change(self, cr, uid, ids, pricelist, product, qty=0,
            uom=False, qty_uos=0, uos=False, name='', partner_id=False,
            lang=False, update_tax=True, date_order=False, packaging=False, fiscal_position=False, flag=False):
            
        res = super(sale_order_line, self).product_id_change(cr, uid, ids, pricelist, product, qty,uom,
                        qty_uos, uos, name, partner_id,lang, update_tax, 
                        date_order, packaging, fiscal_position, flag)
        if product:
            plversions_search_args = [
                ('pricelist_id', '=', pricelist),
                '|',
                ('date_start', '=', False),
                ('date_start', '<=', date_order),
                '|',
                ('date_end', '=', False),
                ('date_end', '>=', date_order),
        ]
            plversion_ids = self.pool.get('product.pricelist.version').search(cr, uid, plversions_search_args)
            cr.execute('SELECT date,product_id '
                'FROM product_pricelist_item '
                'WHERE product_id = %s '
                'AND price_version_id = %s '
                'ORDER BY sequence ASC ',
                (product,plversion_ids[0],))
            dat =  cr.dictfetchall()
            res['value'].update({'date_cot':dat[0]['date'],})
        return res
sale_order_line()
